pcl::IntegralImage2D< DataType, Dimension > Class Template Reference

Determines an integral image representation for a given organized data array. More...

`#include <pcl/features/integral_image2D.h>`

## Public Types

typedef Eigen::Matrix< typename IntegralImageTypeTraits< DataType >::IntegralType, Dimension, 1 > | ElementType
typedef Eigen::Matrix< typename IntegralImageTypeTraits< DataType >::IntegralType, second_order_size, 1 > | SecondOrderType

## Public Member Functions

| IntegralImage2D (bool compute_second_order_integral_images)
| Constructor for an Integral Image. More...
virtual | ~IntegralImage2D ()
| Destructor. More...
void | setSecondOrderComputation (bool compute_second_order_integral_images)
| sets the computation for second order integral images on or off. More...
void | setInput (const DataType *data, unsigned width, unsigned height, unsigned element_stride, unsigned row_stride)
| Set the input data to compute the integral image for. More...
ElementType | getFirstOrderSum (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the first order sum within a given rectangle. More...
ElementType | getFirstOrderSumSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the first order sum within a given rectangle. More...
SecondOrderType | getSecondOrderSum (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the second order sum within a given rectangle. More...
SecondOrderType | getSecondOrderSumSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the second order sum within a given rectangle. More...
unsigned | getFiniteElementsCount (unsigned start_x, unsigned start_y, unsigned width, unsigned height) const
| Compute the number of finite elements within a given rectangle. More...
unsigned | getFiniteElementsCountSE (unsigned start_x, unsigned start_y, unsigned end_x, unsigned end_y) const
| Compute the number of finite elements within a given rectangle. More...

## Static Public Attributes

static const unsigned | second_order_size = (Dimension * (Dimension + 1)) >> 1

## Detailed Description

### template<class DataType, unsigned Dimension>
class pcl::IntegralImage2D< DataType, Dimension >

Determines an integral image representation for a given organized data array.

Author
  Suat Gedikli

Definition at line 107 of file integral_image2D.h.

## Member Typedef Documentation

template<class DataType, unsigned Dimension>

typedef Eigen::Matrix<typename IntegralImageTypeTraits<DataType>::IntegralType, Dimension, 1> pcl::IntegralImage2D< DataType, Dimension >::ElementType

Definition at line 111 of file integral_image2D.h.

template<class DataType, unsigned Dimension>

typedef Eigen::Matrix<typename IntegralImageTypeTraits<DataType>::IntegralType, second_order_size, 1> pcl::IntegralImage2D< DataType, Dimension >::SecondOrderType

Definition at line 112 of file integral_image2D.h.

## Constructor & Destructor Documentation

template<class DataType, unsigned Dimension>

pcl::IntegralImage2D< DataType, Dimension >::IntegralImage2D | ( | bool | compute_second_order_integral_images | ) |

inline

Constructor for an Integral Image.

Parameters

  [in] | compute_second_order_integral_images | set to true if we want to compute a second order image

Definition at line 117 of file integral_image2D.h.

template<class DataType, unsigned Dimension>

virtual pcl::IntegralImage2D< DataType, Dimension >::~IntegralImage2D | ( |  | ) |

inline virtual

Destructor.

Definition at line 129 of file integral_image2D.h.

## Member Function Documentation

template<typename DataType , unsigned Dimension>

unsigned pcl::IntegralImage2D< DataType, Dimension >::getFiniteElementsCount | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the number of finite elements within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 98 of file integral_image2D.hpp.

template<typename DataType , unsigned Dimension>

unsigned pcl::IntegralImage2D< DataType, Dimension >::getFiniteElementsCountSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the number of finite elements within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 140 of file integral_image2D.hpp.

template<typename DataType , unsigned Dimension>

pcl::IntegralImage2D< DataType, Dimension >::ElementType pcl::IntegralImage2D< DataType, Dimension >::getFirstOrderSum | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the first order sum within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 70 of file integral_image2D.hpp.

Referenced by pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computePointNormal().

template<typename DataType , unsigned Dimension>

pcl::IntegralImage2D< DataType, Dimension >::ElementType pcl::IntegralImage2D< DataType, Dimension >::getFirstOrderSumSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the first order sum within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 112 of file integral_image2D.hpp.

template<typename DataType , unsigned Dimension>

pcl::IntegralImage2D< DataType, Dimension >::SecondOrderType pcl::IntegralImage2D< DataType, Dimension >::getSecondOrderSum | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | width,
|  | unsigned | height
| ) |  | const

inline

Compute the second order sum within a given rectangle.

Parameters

  [in] | start_x | x position of rectangle
  [in] | start_y | y position of rectangle
  [in] | width | width of rectangle
  [in] | height | height of rectangle

Definition at line 84 of file integral_image2D.hpp.

Referenced by pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computePointNormal().

template<typename DataType , unsigned Dimension>

pcl::IntegralImage2D< DataType, Dimension >::SecondOrderType pcl::IntegralImage2D< DataType, Dimension >::getSecondOrderSumSE | ( | unsigned | start_x,
|  | unsigned | start_y,
|  | unsigned | end_x,
|  | unsigned | end_y
| ) |  | const

inline

Compute the second order sum within a given rectangle.

Parameters

  [in] | start_x | x position of the start of the rectangle
  [in] | start_y | x position of the start of the rectangle
  [in] | end_x | x position of the end of the rectangle
  [in] | end_y | x position of the end of the rectangle

Definition at line 126 of file integral_image2D.hpp.

template<typename DataType, unsigned Dimension>

void pcl::IntegralImage2D< DataType, Dimension >::setInput | ( | const DataType * | data,
|  | unsigned | width,
|  | unsigned | height,
|  | unsigned | element_stride,
|  | unsigned | row_stride
| ) |  |

Set the input data to compute the integral image for.

Parameters

  [in] | data | the input data
  [in] | width | the width of the data
  [in] | height | the height of the data
  [in] | element_stride | the element stride of the data
  [in] | row_stride | the row stride of the data

Definition at line 54 of file integral_image2D.hpp.

template<typename DataType , unsigned Dimension>

void pcl::IntegralImage2D< DataType, Dimension >::setSecondOrderComputation | ( | bool | compute_second_order_integral_images | ) |

sets the computation for second order integral images on or off.

Parameters

  compute_second_order_integral_images |

Definition at line 47 of file integral_image2D.hpp.

## Member Data Documentation

template<class DataType, unsigned Dimension>

const unsigned pcl::IntegralImage2D< DataType, Dimension >::second_order_size = (Dimension * (Dimension + 1)) >> 1

static

Definition at line 110 of file integral_image2D.h.

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/integral_image2D.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/integral_image2D.hpp